<?php

$ScriptStartTime = GetMicrotime();

if(isset($_SERVER['REMOTE_ADDR'])) session_start();

// SQL injection hack protection
foreach($_POST as $Index => $Item)
{
  if(is_array($_POST[$Index])) 
    foreach($_POST[$Index] as $Index2 => $Item2) $_POST[$Index][$Index2] = addslashes($Item2);
  else $_POST[$Index] = addslashes($_POST[$Index]);
}
foreach($_GET as $Index => $Item) $_GET[$Index] = addslashes($_GET[$Index]);

include_once('config.php');
include_once('error.php');
include_once('databaseconection.php');
include_once('global_function.php');
include_once('rss.php');
include_once('system.php');

$Database = new Database($Config['Database']['Host'], $Config['Database']['User'], $Config['Database']['Password']); 
$Database->SQLCommand('SET NAMES '.$Config['Database']['Charset']);
$Database->SelectDatabase($Config['Database']['Database']);    

$TranslationTree = GetTranslationTree();
$LanguageList = GetLanguageList();

$System = new System();
$System->Init();

function GetMicrotime()
{
  list($Usec, $Sec) = explode(' ', microtime());
  return ((float)$Usec + (float)$Sec);
}

function ShowShoutbox()
{
  global $Database, $Config;
  
  echo('<strong><a href="'.$Config['Web']['BaseURL'].'action.php?action=ShoutBoxView">Shoutbox:</a></strong>');
  if(Licence(LICENCE_USER)) echo(' <a href="'.$Config['Web']['BaseURL'].'action.php?action=shoutbox">Vložit</a>');
  echo('<div class="box"><table>');
  $ID = $Database->SQLCommand('SELECT * FROM shoutbox ORDER BY ID DESC LIMIT 20');
  while($Line = mysql_fetch_assoc($ID))
    echo('<tr><td><strong>'.$Line['user'].'</strong>: '.htmlspecialchars($Line['text']).'</td></tr>');
  echo('</table></div>');
}

function ShowTopBar()
{
  global $Config, $Database;
  
  echo('<div class="Menu">');
    echo('<span class="MenuItem"></span>');
  if(Licence(LICENCE_USER))
  {
    $DbResult = $Database->SQLCommand('SELECT `team`, `user` FROM `user` WHERE ID='.$_SESSION['UserID']);
    $User = mysql_fetch_assoc($DbResult);
    $DbResult = $Database->SQLCommand('SELECT `Id`, `Name` FROM `Team` WHERE Id='.$User['team']);
    $Team = mysql_fetch_assoc($DbResult);

    //echo('<span class="MenuItem">Moje překlady: <a href="">Dokončené</a> <a href="">Rozpracované</a> <a href="">Exporty</a> Tým: <a href="">'.$Team['name'].'</a></span>');
    echo('<span class="MenuItem2">'.$User['user'].' <a href="'.$Config['Web']['BaseURL'].'?Logout">Odhlášení</a> <a href="'.$Config['Web']['BaseURL'].'Options.php">Nastavení</a></span>');
  } else 
  {
    echo('<span class="MenuItem2"><form action="?" method="post"> Jméno: <input type="text" name="LoginUser" size="8 " /> Heslo: <td><input type="password" name="LoginPass" size="8" /> <input type="submit" value="Přihlásit" /></form> &nbsp; <a href="'.$Config['Web']['BaseURL'].'registrace.php">Registrace</a></span>');
  }
  echo('</div>');
}

function ShowLoginBox()
{
  if(Licence(LICENCE_USER)) 
  {
     // echo 'Jste přihlášen jako: <b>'.$_SESSION['User'].'</b> <a href="index.php?Logout">Odhlásit</a>';
  } else 
  {
    echo('<strong>Přihlášení:</strong>
  <form action="" method="post">
  <table>
    <tr>
      <td><input type="text" name="LoginUser" size="13" /></td>
    </tr>
    <tr>
      <td><input type="password" name="LoginPass" size="13" /></td>
    </tr>
    <tr>
      <th><input type="submit" value="Přihlásit" /></th>
    </tr>
  </table>
  </form>');
  }
}

function ShowSearchBox()
{
  global $Config;
  
  echo('<strong>Hledání:</strong>'.
  '<form action="'.$Config['Web']['BaseURL'].'action.php" method="get"><div>'.
  '<input type="hidden" name="action" value="search" />'.
  '<table>'.
  '<tr>'.
      '<td><input type="text" name="search" size="13" /></td>'.
    '</tr>'.
    '<tr>'.
      '<th><input type="submit" value="Hledat" /></th>'.
    '</tr>'.
  '</table></div>'.
  '</form>');
}

function ShowMainMenu()
{ 
  global $TranslationTree, $Config;
  
  $Menu = array
  (
    $Config['Web']['BaseURL'].'index.php' => array(LICENCE_ANONYMOUS, 'Hlavní stránka', 'Domů'),
    'http://wow.zdechov.net/forum/viewforum.php?f=22' => array(LICENCE_ANONYMOUS, 'Diskuze na téma překládání', 'Fórum projektu'),
    $Config['Web']['BaseURL'].'dictionary.php' => array(LICENCE_ANONYMOUS, 'Slovník WoW výrazů', 'Slovníček'),
    $Config['Web']['BaseURL'].'statistic.php' => array(LICENCE_ANONYMOUS, 'Stav dokončení překládů', 'Stav dokončení'),
    $Config['Web']['BaseURL'].'userlist.php?action=nofilter' => array(LICENCE_ANONYMOUS, 'Seznam registrovaných uživatelů', 'Překladatelé'),
    $Config['Web']['BaseURL'].'team.php?search=' => array(LICENCE_ANONYMOUS, 'Seznam překladatelských týmů', 'Týmy'),
    $Config['Web']['BaseURL'].'export/' => array(LICENCE_ANONYMOUS, 'Zde si můžete stáhnout přeložené texty', 'Exporty'),
    $Config['Web']['BaseURL'].'download.php' => array(LICENCE_ANONYMOUS, 'Stahování různých pomocných souborů a programů', 'Soubory'),
    $Config['Web']['BaseURL'].'info.php' => array(LICENCE_ANONYMOUS, 'Informace k překladu hry', 'Informace'),
    $Config['Web']['BaseURL'].'TranslationList.php?action=grouplist' => array(LICENCE_ANONYMOUS, 'Informace o překladových skupinách', 'Zdroje dat'), 
    $Config['Web']['BaseURL'].'banners.php' => array(LICENCE_ANONYMOUS, 'Informace k propagaci tohoto projektu', 'Propagace'),
    $Config['Web']['BaseURL'].'version.php' => array(LICENCE_ANONYMOUS, 'Seznam verzí herního klienta', 'Verze hry'), 
    $Config['Web']['BaseURL'].'aowow' => array(LICENCE_ANONYMOUS, 'Vyhledávací databáze podobná WoWHead s překlady', 'AoWoW'), 
    $Config['Web']['BaseURL'].'server.php' => array(LICENCE_ANONYMOUS, 'Pomocný WoW server pro překladatele', 'Test server'), 
'http://embed.mibbit.com/?server=game.zdechov.net%3A6667&amp;channel=%23wowpreklad&amp;forcePrompt=true&amp;charset=utf-8' => array(LICENCE_ANONYMOUS, 'IRC chat pro překladatele', 'Chat'),
    $Config['Web']['BaseURL'].'admin.php' => array(LICENCE_ADMIN, 'Volby pro správu', 'Administrace'), 
  );
  
  echo('<strong>Hlavní menu:</strong>'.
    '<div class="verticalmenu"><ul>');

  foreach($Menu as $MenuTarget => $MenuItem)
  {
  if(isset($MenuItem[3])) $OnClick = ' onclick="'.$MenuItem[3].'"'; else $OnClick = '';
  if(Licence($MenuItem[0])) echo('<li><a class="verticalmenua" title="'.$MenuItem[1].'" href="'.$MenuTarget.'"'.$OnClick.'>'.$MenuItem[2].'</a></li>');
  }    
  echo('</ul></div>');
}

function ShowTranslatedMenu()
{
  global $TranslationTree, $Config, $Database;

  echo('<strong>Překladové skupiny:</strong><br /><div id="TranslationMenu">');
  if(Licence(LICENCE_USER)) 
  {
    echo ('<a title="Všechny překlady, které jste přeložil" href="'.$Config['Web']['BaseURL'].'TranslationList.php?user='.$_SESSION['UserID'].'&amp;action=userall">Všechny moje texty</a><br />');
    echo ('<a title="Všechny překlady, které jste rozepsal a nedokončil" href="'.$Config['Web']['BaseURL'].'TranslationList.php?user='.$_SESSION['UserID'].'&amp;not&amp;action=userall">Rozpracované texty</a>');
    //TODO: počet nedokončených  
    echo ('<br /><br />');
  }
  foreach($TranslationTree as $Group)
  {
    echo('<div id="menuitem-group'.$Group['Id'].'" onmousemove="show(\'group'.$Group['Id'].'\')" onmouseout="hide(\'group'.$Group['Id'].'\')">
      <a href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=filter">'.$Group['Name'].'</a></div>       
      <div id="group'.$Group['Id'].'" class="hidden-menu-item" onmousemove="show(\'group'.$Group['Id'].'\')" onmouseout="hide(\'group'.$Group['Id'].'\')">');
    echo('&nbsp;<a title="Zde můžete začít překládat" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=notran">Nepřeložené</a><br />
      &nbsp;<a title="Přeložené texty, můžete zde hlasovat, nebo opravovat překlady" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=Translate">Přeložené</a><br />');
  $ID = $Database->SQLCommand('SELECT * FROM connexion WHERE `Group` = '.$Group['Id']);
    if (mysql_num_rows($ID) > 0)  
    echo('&nbsp;<a title="Vypsání souvislostí" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=connexion_list">Souvislosti</a><br />');
 
  if(Licence(LICENCE_USER)) 
    {
      echo('&nbsp;<a title="Nedokončené překlady" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=mydevelop">Rozepsané</a><br />
        &nbsp;<a title="Všechny překlady, které jste přeložil" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=my">Vlastní</a><br />');
    }
    echo('&nbsp;<a title="Sestavit speciální filtr" href="'.$Config['Web']['BaseURL'].'TranslationList.php?group='.$Group['Id'].'&amp;action=filter">Filtr</a><br />');
    echo('</div>');
  }
  echo ('</div>');
}

function ShowOnlineUserList()
{
  global $Database, $Moderators;
  
  echo('Online překladatelé:<br />');
  $ID = $Database->SQLCommand('SELECT user, GM, ID FROM `user` WHERE LastLogin >= Now() - 300 AND ((LastLogout < LastLogin) OR (ISNULL(LastLogout)))');
  while ($Line = mysql_fetch_assoc($ID))
  {
    if(Licence(LICENCE_MODERATOR)) $Name = '<a href="user.php?user='.$Line['ID'].'">'.$Line['user'].'</a>';
    else $Name = $Line['user'];
    //if($Line['GM'] <> 0) $TextGM = '<small>('.$Moderators[$Line['GM']].')</small>';
    //else 
    $TextGM = '';
    echo('<strong>'.$Name.'</strong>'.$TextGM.'<br />');
  }
}

function CheckLogin()
{
  global $Database;
  
  if(!array_key_exists('UserID', $_SESSION)) $_SESSION['UserID'] = '';
  if(!array_key_exists('User', $_SESSION)) $_SESSION['User'] = 'NotRegistred';
  if(!array_key_exists('Pass', $_SESSION)) $_SESSION['Pass'] = '';

  // Přihlášení
  if(array_key_exists('LoginUser', $_POST))
  {
    $_SESSION['User'] = $_POST['LoginUser'];
    $_SESSION['Pass'] = $_POST['LoginPass'];

    $DbResult = $Database->SQLCommand('SELECT * FROM user WHERE LOWER(user) = LOWER("'.$_SESSION['User'].'") AND pass = sha1(CONCAT(sha1("'.$_SESSION['Pass'].'"), Salt))');
    if(mysql_num_rows($DbResult) == 0)
    {
       echo('<script> alert("Jméno nebo heslo bylo zadáno špatně!"); </script>');
       $_SESSION['UserID'] = ''; 
       $_SESSION['User'] = '';
       $_SESSION['Pass'] = '';
    } else
    {
      $User = mysql_fetch_assoc($DbResult);
      $_SESSION['UserID'] = $User['ID']; 
      $_SESSION['User'] = $User['user'];
      WriteLog('Login: '.$_SESSION['User'], 3);
    }
  }

  // Odhlášení
  if(array_key_exists('Logout', $_GET) and ($_SESSION['User'] != ''))  
  {
    WriteLog('Odhlášení', 3);
    if(is_numeric($_SESSION['UserID']))
      $Database->SQLCommand('UPDATE user SET LastLogout = NOW() WHERE ID = '.$_SESSION['UserID']);
    $_SESSION['User'] = '';
    $_SESSION['Pass'] = '';
    $_SESSION['UserID'] = '';
  }

  // Záznam o aktivitě
  if(Licence(0) and array_key_exists('REMOTE_ADDR', $_SERVER)) 
    $Database->SQLCommand('UPDATE user SET LastIP = "'.$_SERVER['REMOTE_ADDR'].'", LastLogin = NOW() WHERE ID = '.$_SESSION['UserID']);
}

function ShowPage()
{
  global $Config, $Database, $RSSChannels, $PageFooterRequested;  
  
  echo('<?xml version="1.0" encoding="'.$Config['Web']['Charset'].'"?>
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs">'.
'<head>'.
'<meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />'.
'<meta name="keywords" content="wow, quest, questy, questů, preklad, mangos, překlad, překládání, přeložený, přeložení, čeština, world of warcraft, open source, free, addon" />'.
'<meta name="description" content="Projekt překládání textů hry World of Warcraft" />'.
'<meta name="robots" content="all" />'.
'<link rel="stylesheet" href="'.$Config['Web']['BaseURL'].'style/style.css" type="text/css" media="all" />'.
'<script type="text/javascript" src="'.$Config['Web']['BaseURL'].'style/global.js"></script>'.
'<link rel="SHORTCUT ICON" href="'.$Config['Web']['BaseURL'].'images/favicon.ico" />');
  if(isset($RSSChannels)) 
  foreach($RSSChannels as $Channel)
    echo(' <link rel="alternate" title="'.$Channel['Title'].'" href="'.$Channel['URL'].'" type="application/rss+xml" />');
  echo('<title>Projekt překládání textů WoW</title>
</head>
<body>
<table id="bannertable"><tr>
  <td id="banner1"></td>
  <td id="banner"><div id="bannertitle">Projekt překládání textů WoW</div></td>
  <td id="banner2"></td></tr>
</table>');

  CheckLogin();
  ShowTopBar();

  echo('<table class="page"><tr><td class="menu">');
  ShowMainMenu();
      
  // echo('<br />');    
  //ShowLoginBox();
  //echo('<br />');
  ShowOnlineUserList();
  echo('<br />');
  ShowSearchBox();
  echo('</td><td id="border-left"></td><td class="content">');
  $PageFooterRequested = true;
}

$UnitNames = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB');
 
function HumanSize($Value)
{
  global $UnitNames;

  $UnitIndex = 0;
  while($Value > 1024)
  {
    $Value = round($Value / 1024, 3);
    $UnitIndex++;
  }
  return($Value.' '.$UnitNames[$UnitIndex]);
}

function ShowFooter()
{
  global $Database, $Config, $ScriptStartTime, $PageFooterRequested;

  if(isset($PageFooterRequested)) 
  {
    $ScriptGenerateDuration = round(GetMicrotime() - $ScriptStartTime, 2);

    echo('</td>');
    echo('<td class="menu2">');
    ShowTranslatedMenu();
    echo('<br />');
    ShowShoutBox();
    echo('</td>'.
  '</tr><tr>'.
  '<td colspan="4" class="page-bottom">Autoři: maron, chronos &nbsp; <a href="http://wowpreklad.zdechov.net/trac/wowpreklad/browser/trunk">Zdrojové soubory</a> &nbsp; '.
  '<a href="http://wowpreklad.zdechov.net/trac/wowpreklad/log/trunk?verbose=on">Novinky</a> &nbsp; '.
  '<a href="http://counter.cnw.cz/"><img src="http://counter.cnw.cz/monika.cgi?wowpreklad&amp;5&amp;000000&amp;FFFFFF&amp;on" alt="CNW:Counter" /></a>
    <script type="text/javascript">
    <!--
    document.write("<a href=\"http://counter.cnw.cz\" target=\"_parent\"><img src=\"http://counter.cnw.cz/trackit.cgi?wowpreklad&t3&" + escape(top.document.referrer) + "\" alt=\"CNW:Tracker\" border=\"0\" width=\"1\" height=\"1\"><\/a>");
    // -->
    </script>');

    echo('</td></tr>');
    if($Config['Web']['ShowRuntimeInfo'] == true) echo('<tr><td colspan="3" style="text-align: center;">Doba generování: '.$ScriptGenerateDuration.' s / '.ini_get('max_execution_time').' s &nbsp;&nbsp; Použitá paměť: '.HumanSize(memory_get_peak_usage(FALSE)).' / '.ini_get('memory_limit').'B &nbsp;&nbsp; <a href="http://validator.w3.org/check?uri='.htmlentities('http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'].'?'.$_SERVER['QUERY_STRING']).'">HTML validator</a></td></tr>');
    echo('</table>'.
      '</body>'.
      '</html>');
    $Database->Disconnect();
  } 
}

function GetQueryStringArray($QueryString)
{
  $Result = array();
  $Parts = explode('&', $QueryString);
  foreach($Parts as $Part)
  {
    if($Part != '')
    {
      if(!strpos($Part, '=')) $Part .= '=';
      $Item = explode('=', $Part);
      $Result[$Item[0]] = $Item[1];
    }
  }
  return($Result);
}

function SetQueryStringArray($QueryStringArray)
{
  $Parts = array();
  foreach($QueryStringArray as $Index => $Item)
  {
    $Parts[] = $Index.'='.$Item;
  }
  return(implode('&', $Parts));
}

?>
