<?php

include_once('includes/global.php');
  
function ShowNews()
{
  global $Database;

  $Output = '<strong>Změny systému:</strong><div class="NewsBox">';
  $DbResult = $Database->SQLCommand('SELECT news.Time, user.user, news.Text FROM news JOIN user ON user.ID = news.User ORDER BY Time DESC LIMIT 10');
  while($DbRow = mysql_fetch_assoc($DbResult))
    $Output .= '<div><strong>'.$DbRow['user'].' ('.date('d.m.Y', MysqlDateTimeToTime($DbRow['Time'])).')</strong> <br />'.$DbRow['Text'].'</div>';  
  $Output .= '</div>';
  return($Output);
}

function ShowLastTranslated()
{
  global $Database;

  $Output = '<br /><strong>Poslední překlady:</strong><div class="NewsBox">';
  $DbResult = $Database->SQLCommand('SELECT date,user.user,text FROM log JOIN user ON user.ID = log.User WHERE type = 1 ORDER BY date DESC LIMIT 20');
  while($DbRow = mysql_fetch_assoc($DbResult))
    $Output .= '<strong>'.$DbRow['user'].' ('.date('d.m.Y', MysqlDateTimeToTime($DbRow['date'])).')</strong>
    '.$DbRow['text'].' <br />';  
  $Output .= '</div>';
  return($Output);
}

function ShowRSSChannel()
{
  global $Database, $Config;
  
  $Items = array();  
  if($_GET['rss'] == 'news')
  {
    $DbResult = $Database->SQLCommand('SELECT UNIX_TIMESTAMP(news.Time), news.Time, user.user, news.Text FROM news JOIN user ON user.ID = news.User ORDER BY Time DESC LIMIT 10');
    while($DbRow = mysql_fetch_assoc($DbResult)) 
    {
      $Items[] = array
    (
        'Title' => $DbRow['user'].'('.date('d.m.Y', MysqlDateTimeToTime($DbRow['Time'])).')',
        'Link' =>  $Config['Web']['BaseURL'],
        'Description' => $DbRow['Text'],
        'Time' => $DbRow['UNIX_TIMESTAMP(news.Time)'],
      );
    } 
    echo(GenerateRSS(array
    (
      'Title' => 'WoW překlad - Změny systému',
      'Link' => $Config['Web']['BaseURL'],
      'Description' => 'Překlad textů WoW',
      'WebmasterEmail' => $Config['Web']['AdminEmail'],
      'Items' => $Items,
    )));
  } else
  if($_GET['rss'] == 'translation')
  {
    $DbResult = $Database->SQLCommand('SELECT UNIX_TIMESTAMP(date), date, user.user, text FROM log JOIN user ON user.ID = log.User WHERE type = 1 ORDER BY date DESC LIMIT 100');
    while($DbRow = mysql_fetch_assoc($DbResult)) 
    {
      $Items[] = array
    (
        'Title' => strip_tags($DbRow['text'].' ('.$DbRow['user'].')'),
        'Link' =>  $Config['Web']['BaseURL'],
        'Description' => $DbRow['text'],
        'Time' => $DbRow['UNIX_TIMESTAMP(date)'],
      );
    } 
    echo(GenerateRSS(array
    (
      'Title' => 'WoW překlad - Poslední překlady',
      'Link' => $Config['Web']['BaseURL'],
      'Description' => 'Překlad textů WoW',
      'WebmasterEmail' => $Config['Web']['AdminEmail'],
      'Items' => $Items,
    )));
  } else
  if($_GET['rss'] == 'shoutbox')
  {
  $TitleLength = 50;
  mb_internal_encoding('utf-8');
    $DbResult = $Database->SQLCommand('SELECT UNIX_TIMESTAMP(date), user, text FROM shoutbox ORDER BY ID DESC LIMIT 20');
    while($DbRow = mysql_fetch_assoc($DbResult)) 
    {
    $Title = mb_substr($DbRow['text'], 0, $TitleLength);
    if(mb_strlen($Title) == $TitleLength) $Title .= '...';
      $Items[] = array
    (
        'Title' => $DbRow['user'].': '.$Title,
        'Link' =>  $Config['Web']['BaseURL'],
        'Description' => $DbRow['text'],
        'Time' => $DbRow['UNIX_TIMESTAMP(date)'],
      );
    } 
    echo(GenerateRSS(array
    (
      'Title' => 'WoW překlad - Shoutbox',
      'Link' => $Config['Web']['BaseURL'],
      'Description' => 'Překlad textů WoW',
      'WebmasterEmail' => $Config['Web']['AdminEmail'],
      'Items' => $Items,
    )));
  }
}

if(array_key_exists('rss', $_GET))
{
  ShowRSSChannel();
} else
{
  $RSSChannels = array(
    array('Title' => 'Změny systému', 'URL' => '?rss=news'),
    array('Title' => 'Poslední překlady', 'URL' => '?rss=translation'),
    array('Title' => 'Shoutbox', 'URL' => '?rss=shoutbox'),
  );
  ShowPage();
  
  echo('<br />'.  
  '<table class="Home"><tr><td>'.
  'Nacházíte se na stránce projektu překládání textů ze hry World of Warcraft (WoW).<br />'.
  '<ul>'.
  '<li>Projekt je provozován jako otevřený vyznává principy volnosti a otevřenosti. Proto jsou texty volně ke stažení.</li>'.
  '<li>Projekt slouží k týmovému překladu. Kdokoliv může přispět přeložením textů a uveřejněním odkazu popř. banneru na svých stránkách.</li>'.
  '<li>Projekt není zaměřen pouze na jeden server a umožňuje společné překládání lidem z různých serverů. Překladatelé mohou překládat v týmech podle jména svého serveru a exportovat texty pouze od vybraných překladatelů.</li>'.
  '<li>Přeložené texty lze volně stahovat v různých tvarech jako XML, SQL, Addon a Lua. Přeložené texty lze tedy snadno importovat do svého free serveru nebo použít v jiných projektech.</li>'.
  '<li>Cílem projektu je přeložit všechny texty ze hry. Nikoliv pouze texty výprav (questů).</li>'.
  '<li>Texty lze překládat do dvou jazyků, češtiny a slovenštiny.</li>'.
  '</ul>'.ShowLastTranslated().'</td><td class="news-box">'.ShowNews().'</td></tr></table>');
 
         
  ShowFooter();
}

?>
